//-------------------------------------------------------------------------------------------------------
//
// SPI
//
//-------------------------------------------------------------------------------------------------------


#include <avr/io.h>

#include "SPI.h"
#include "Config.h"
#include "EEPROM.h"


//-------------------------------------------------------------------------------------------------------
// SPI initialisieren

void F_SPI_init(void)
{
	// Ein- und Ausgnge definieren
	SET(MCP2515_SS);
	SET_OUTPUT(MCP2515_SS);
	
	RESET(P_SCK);
	RESET(P_MOSI);
	RESET(P_MISO);
	
	SET_OUTPUT(P_SCK);
	SET_OUTPUT(P_MOSI);
	SET_INPUT(P_MISO);
	
	SET_INPUT(MCP2515_INT);
	SET(MCP2515_INT);
}


//-------------------------------------------------------------------------------------------------------
// Daten ber SPI senden

void F_SPI_senden(uint8_t Daten)
{
	// Sendepuffer beschreiben
	SPDR = Daten;

	// warten bis gesendet
	while(!(SPSR & (1<<SPIF)));
}


//-------------------------------------------------------------------------------------------------------
// Daten ber SPI lesen

uint8_t F_SPI_lesen(void)
{
	uint8_t Daten = SPDR;
	return Daten;
}


//-------------------------------------------------------------------------------------------------------
// SPI Register fr MCP2515 setzen

void F_SPI_Reg_MCP2515(void)
{
	SPCR = (1<<SPE) | (1<<MSTR) | (0<<SPR1) | (1<<SPR0);
	SPSR = 0;
}
